# OG Browser

El OpenGnsys Browser es un navegador limitado de tipo quiosco, basado en Qt6/Chrome.

## Compilación

Compilar require Qt6. Hay paquetes disponibles para todas las distribuciones modernas.

El módulo de terminal requiere `lxqt-build-tools` porque es parte del proyecto LxQt, pero el navegador resultante no require LxQt.

### Dependencias

#### Ubuntu 22.04

    # apt install build-essential cmake g++ qt6-base-dev qt6-webengine-dev linguist-qt6  libgl1-mesa-dev qt6-tools-dev qt6-l10n-tools  qt6-tools-dev-tools libqt6core5compat6-dev lxqt-build-tools qt6-webengine-dev-tools libqt6webenginecore6-bin

### Compilar
El sistema esta basado en CMake. Para compilar:


    git clone https://ognproject.evlt.uma.es/gitea/unizar/ogbrowser.git
    cd ogbrowser
    mkdir build
    cd build
    cmake ..
    make -j8 # 8 cores -- cambiar según el numero de cores del hardware


### Traducción

Se usa el sistema de traducción de Qt. Los archivos de lenguaje se encuentran en src/i18n. El sistema de traducción busca cadenas identificadas for `tr("texto")` en el código fuente,
y las reemplaza por versiones traducidas.

Para actualizar los archivos de traducción con cadenas nuevas y/o modificadas en el código, ejecutar `src/update_translations.sh`.

Para traducir, ejecutar Qt Linguist, por ejemplo:

    linguist-qt6 i18n/OGBrowser_ca.ts


## Uso

    src/OGBrowser URL

Por ejemplo:

    src/OGBrowser http://example.com


## URLs especiales:

El navegador reconoce URLs especiales dentro de los documentos, que pueden usarse
para ejecutar comandos locales.

* command - Ejecuta un comando
* command+output - Ejecuta un comando y muestra la salida
* command+confirm - Pregunta antes de ejecutar un comando
* command+confirm+output - Pregunta antes de ejecutar un comando y muestra la salida
* command+output+confirm - Idéntico al anterior


Ejemplo:

    <a href="command+confirm+output:/bin/ping -c 5 127.0.0.1">Ejecutar</a>

Esto crea un enlace que al hacerse click, ejecuta el comando ping y muestra el resultado en una ventana.


## Proxy

Usa el proxy del sistema, incluyendo las variables de entorno: HTTP_PROXY, HTTPS_PROXY, ALL_PROXY, NO_PROXY

## Modo administrativo

El administrador dispone de una consola y mas información sobre la ejecución de comandos.

Se activa estableciendo la variable de entorno `ogactiveadmin=true`

## Modo quiosco

Se puede activar el modo quiosco que impide la salida del navegador con Alt+F4.

Se activa estableciendo la variable de entorno `OGKIOSKMODE=true`

