#pragma once

#include <QWebEngineUrlSchemeHandler>
#include <QObject>

#define COMMAND "command"
#define COMMAND_CONFIRM "command+confirm"
#define COMMAND_WITH_CONFIRMATION "commandwithconfirmation"  // Backwards compatibility
#define COMMAND_OUTPUT "command+output"
#define COMMAND_CONFIRM_OUTPUT "command+confirm+output"
#define COMMAND_OUTPUT_CONFIRM "command+output+confirm"
#define ENVIRONMENT "OGLOGFILE,ogactiveadmin,DEFAULTSPEED"

class OGBrowserUrlHandlerCommand : public QWebEngineUrlSchemeHandler {
    Q_OBJECT
public:

    OGBrowserUrlHandlerCommand(QObject *parent = nullptr) : QWebEngineUrlSchemeHandler(parent) {

    };

    virtual ~OGBrowserUrlHandlerCommand() {

    };

    virtual void requestStarted(QWebEngineUrlRequestJob *job);
    bool askConfirmation() const { return m_ask_confirmation; }
    bool returnOuput() const { return m_return_output; }

    void setAskConfirmation(const bool ask) { m_ask_confirmation = ask; }
    void setReturnOutput(const bool retOutput) { m_return_output = retOutput; }

signals:
    void command(const QString &command, bool confirm, bool returnOutput);


private:

    bool m_ask_confirmation = false;
    bool m_return_output = false;

};


